Index: drivers/scsi/nsp32.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/nsp32.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/nsp32.c	22 Jul 2004 19:50:05 -0000	1.1
+++ drivers/scsi/nsp32.c	4 Aug 2004 01:29:35 -0000	1.2
@@ -1,8 +1,8 @@
 /*
  * NinjaSCSI-32Bi Cardbus, NinjaSCSI-32UDE PCI/CardBus SCSI driver
- * Copyright (C) 2001, 2002
+ * Copyright (C) 2001, 2002, 2003
  *      YOKOTA Hiroshi <yokota@netlab.is.tsukuba.ac.jp>
- *      GOTO Masanori <gotom@debian.or.jp>
+ *      GOTO Masanori <gotom@debian.or.jp>, <gotom@debian.org>
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -13,6 +13,14 @@
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
+ *
+ *
+ * Revision History:
+ *   1.0: Initial Release.
+ *   1.1: Add /proc SDTR status.
+ *        Remove obsolete error handler nsp32_reset.
+ *        Some clean up.
+ *   1.2: PowerPC (big endian) support.
  */
 
 #include <linux/version.h>
@@ -25,10 +33,12 @@
 #include <linux/timer.h>
 #include <linux/ioport.h>
 #include <linux/major.h>
-#include <linux/blk.h>
+#include <linux/blkdev.h>
+#include <linux/interrupt.h>
 #include <linux/pci.h>
 #include <linux/delay.h>
 #include <linux/ctype.h>
+#include <linux/interrupt.h>
 
 #include <asm/dma.h>
 #include <asm/system.h>
@@ -39,373 +49,327 @@
 #include <scsi/scsi_ioctl.h>
 #include <scsi/scsi.h>
 
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0))
+# include <linux/blk.h>
+#endif
+
 #include "nsp32.h"
 
 
-static int trans_mode = 0;	/* default: BIOS */
-static int auto_param = 0;	/* default: ON */
-MODULE_PARM(trans_mode, "i");
-MODULE_PARM(auto_param, "i");
-MODULE_PARM_DESC(trans_mode, "transfer mode (0: BIOS 1: Async 2: Ultra20M");
-MODULE_PARM_DESC(auto_param, "AutoParameter mode (0: ON 1: OFF)");
+/***********************************************************************
+ * Module parameters
+ */
+static int       trans_mode = 0;	/* default: BIOS */
+MODULE_PARM     (trans_mode, "i");
+MODULE_PARM_DESC(trans_mode, "transfer mode (0: BIOS(default) 1: Async 2: Ultra20M");
 #define ASYNC_MODE    1
 #define ULTRA20M_MODE 2
 
+static int       auto_param = 0;	/* default: ON */
+MODULE_PARM     (auto_param, "i");
+MODULE_PARM_DESC(auto_param, "AutoParameter mode (0: ON(default) 1: OFF)");
+
+static int       disc_priv  = 1;	/* default: OFF */
+MODULE_PARM     (disc_priv,  "i");
+MODULE_PARM_DESC(disc_priv,  "disconnection privilege mode (0: ON 1: OFF(default))");
+
 MODULE_AUTHOR("YOKOTA Hiroshi <yokota@netlab.is.tsukuba.ac.jp>, GOTO Masanori <gotom@debian.or.jp>");
-MODULE_DESCRIPTION("Workbit NinjaSCSI-32Bi/UDE PCI/CardBus SCSI host bus adapter module");
+MODULE_DESCRIPTION("Workbit NinjaSCSI-32Bi/UDE CardBus/PCI SCSI host bus adapter module");
 MODULE_LICENSE("GPL");
 
-static const char *nsp32_release_version = "1.0";
-
-
-/*
- * structure for DMA/Scatter Gather list
- */
-#define AUTOPARAM_SIZE		(sizeof(int)*0x15)	/* 4x15H = 0x60 */
-#define NSP_SG_SIZE		SG_ALL
-#define NSP32_SG_END_SGT	0x80000000		/* Last SGT marker */
-#define NSP32_SG_CNT_MASK	0x1FFFF
-
-struct nsp32_sgtable {
-	unsigned long		addr;		/* transfer address */
-	unsigned long		len;		/* transfer length.
-						   Bit (24-32) is for SGT_END */
-};
-
-struct nsp32_sglun {
-	struct nsp32_sgtable sgt[NSP_SG_SIZE+1];	/* SG table */
-};
-
-
-/*
- * host data structure
- */
-/* message in/out buffer */
-#define MSGOUTBUF_MAX	13  /* 13 is ok ? */
-#define MSGINBUF_MAX	13
-
-/* flag for trans_method */
-#define NSP32_TRANSFER_BUSMASTER	BIT(0)
-#define NSP32_TRANSFER_MMIO		BIT(1)	/* Not supported yet */
-#define NSP32_TRANSFER_PIO		BIT(2)	/* Not supported yet */
-
-
-/*
- * SCSI TARGET/LUN definition
- */
-#define NSP32_HOST_SCSIID	7	/* SCSI initiator is everytime defined as 7 */
-#define MAX_TARGET		8
-#define MAX_LUN			8	/* XXX: In SPI3, max number of LUN is 64. */
-
+static const char *nsp32_release_version = "1.2";
 
-/*
- * structure for synchronous transfer negotiation data
- */
-#define SYNC_NOT_YET	0
-#define SYNC_OK		1
-#define SYNC_NG		2
-
-struct nsp32_sync_table {
-	unsigned char	period_num;	/* period number */
-	unsigned char	ackwidth;	/* ack width designated by period */
-	unsigned char	start_period;	/* search range - start period */
-	unsigned char	end_period;	/* search range - end period */
-};
 
-
-/*
- * structure for target device static data
+/****************************************************************************
+ * Supported hardware
  */
-/* flag for nsp32_target.sync_flag */
-#define SDTR_INITIATOR		BIT(0)	/* sending SDTR from initiator */
-#define SDTR_TARGET		BIT(1)	/* sending SDTR from target */
-#define SDTR_DONE		BIT(2)	/* exchanging SDTR has been processed */
-
-/* syncronous period value for nsp32_target.config_max */
-#define FAST5M			0x32
-#define FAST10M			0x19
-#define ULTRA20M		0x0c
-
-/* flag for nsp32_target.{sync_offset}, period */
-#define ASYNC_OFFSET		0	/* asynchronous transfer */
-#define SYNC_OFFSET		0xf	/* synchronous transfer max offset */
-
-/* syncreg:
-      07 06 05 04 03 02 01 00
-      ---PERIOD-- ---OFFSET--   */
-#define TO_SYNCREG(period, offset)	(period << 4 | offset)
-
-struct nsp32_target {
-	unsigned char	syncreg;	/* value for SYNCREG  */
-	unsigned char	ackwidth;	/* value for ACKWIDTH */
-	unsigned char	offset;		/* sync offset (0-15) */
-	int		sync_flag;	/* SDTR_*, 0 */
-	int		limit_entry;	/* max speed limit entry designated
-					   by EEPROM configuration */
+static struct pci_device_id nsp32_pci_table[] __devinitdata = {
+	{
+		.vendor      = PCI_VENDOR_ID_IODATA,
+		.device      = PCI_DEVICE_ID_NINJASCSI_32BI_CBSC_II,
+		.subvendor   = PCI_ANY_ID,
+		.subdevice   = PCI_ANY_ID,
+		.driver_data = MODEL_IODATA,
+	},
+	{
+		.vendor      = PCI_VENDOR_ID_WORKBIT,
+		.device      = PCI_DEVICE_ID_NINJASCSI_32BI_KME,
+		.subvendor   = PCI_ANY_ID,
+		.subdevice   = PCI_ANY_ID,
+		.driver_data = MODEL_KME,
+	},
+	{
+		.vendor      = PCI_VENDOR_ID_WORKBIT,
+		.device      = PCI_DEVICE_ID_NINJASCSI_32BI_WBT,
+		.subvendor   = PCI_ANY_ID,
+		.subdevice   = PCI_ANY_ID,
+		.driver_data = MODEL_WORKBIT,
+	},
+	{
+		.vendor      = PCI_VENDOR_ID_WORKBIT,
+		.device      = PCI_DEVICE_ID_WORKBIT_STANDARD,
+		.subvendor   = PCI_ANY_ID,
+		.subdevice   = PCI_ANY_ID,
+		.driver_data = MODEL_PCI_WORKBIT,
+	},
+	{
+		.vendor      = PCI_VENDOR_ID_WORKBIT,
+		.device      = PCI_DEVICE_ID_NINJASCSI_32BI_LOGITEC,
+		.subvendor   = PCI_ANY_ID,
+		.subdevice   = PCI_ANY_ID,
+		.driver_data = MODEL_LOGITEC,
+	},
+	{
+		.vendor      = PCI_VENDOR_ID_WORKBIT,
+		.device      = PCI_DEVICE_ID_NINJASCSI_32BIB_LOGITEC,
+		.subvendor   = PCI_ANY_ID,
+		.subdevice   = PCI_ANY_ID,
+		.driver_data = MODEL_PCI_LOGITEC,
+	},
+	{
+		.vendor      = PCI_VENDOR_ID_WORKBIT,
+		.device      = PCI_DEVICE_ID_NINJASCSI_32UDE_MELCO,
+		.subvendor   = PCI_ANY_ID,
+		.subdevice   = PCI_ANY_ID,
+		.driver_data = MODEL_PCI_MELCO,
+	},
+	{
+		.vendor      = PCI_VENDOR_ID_WORKBIT,
+		.device      = PCI_DEVICE_ID_NINJASCSI_32UDE_MELCO_II,
+		.subvendor   = PCI_ANY_ID,
+		.subdevice   = PCI_ANY_ID,
+		.driver_data = MODEL_PCI_MELCO,
+	},
+	{0,0,},
 };
+MODULE_DEVICE_TABLE(pci, nsp32_pci_table);
 
-typedef struct _nsp32_hw_data {
-	int IrqNumber;
-	int BaseAddress;
-	int NumAddress;
-#define NSP32_MMIO_OFFSET 0x0800
-	unsigned long MmioAddress;
-	unsigned long length;
-
-	Scsi_Cmnd *CurrentSC;
-
-	struct pci_dev *Pci;
-	const struct pci_device_id *pci_devid;
-	struct Scsi_Host *Host;
-	spinlock_t Lock;
-
-	char info_str[100];
-
-	/* allocated memory region */
-	struct nsp32_lunt	*lunt_list;	/* kmalloc region for lunt */
-	struct nsp32_sglun	*sg_list;	/* sglist virtual address */
-	dma_addr_t		sgaddr;		/* physical address of hw_sg_table */
-	unsigned char		*autoparam;	/* auto parameter transfer region */
-	dma_addr_t		apaddr;		/* physical address of autoparam */
-	int 			cur_entry;	/* current sgt entry */
-
-	/* target/LUN */
-	struct nsp32_lunt	*curlunt;	/* Current connected LUN table */
-	struct nsp32_lunt	*lunt[MAX_TARGET][MAX_LUN];  /* All LUN table */
-	struct nsp32_target	*curtarget;	/* Current connected SCSI ID */
-	struct nsp32_target	target[MAX_TARGET];	     /* SCSI ID */
-	int			pid;		/* Current connected target ID */
-	int			plun;		/* Current connected target LUN */
-
-	/* behavior setting parameters */
-	int			trans_method;	/* transfer method flag */
-	int			resettime;	/* Reset time */
-	int 			clock;	       	/* clock dividing flag */
-	struct nsp32_sync_table	*synct;		/* sync_table determined by clock */
-	int			syncnum;	/* the max number of synct element */
-
-	/* message buffer */
-        unsigned char	msgoutbuf[MSGOUTBUF_MAX]; /* msgout buffer */
-	char		msgoutlen;		  /* msgoutbuf length */
-	unsigned char	msginbuf[MSGINBUF_MAX];	  /* megin buffer */
-	char		msginlen;		  /* msginbuf length */
-
-
-} nsp32_hw_data;
 static nsp32_hw_data nsp32_data_base;  /* probe <-> detect glue */
 
 
 /*
- * TIME definition
- */
-#define RESET_HOLD_TIME		10000	/* reset time in us (SCSI-2 says the
-					   minimum is 25us) */
-#define SEL_TIMEOUT_TIME	10000	/* 250ms defined in SCSI specification
-					   (25.6us/1unit) */
-#define ARBIT_TIMEOUT_TIME	100	/* 100us */
-#define REQSACK_TIMEOUT_TIME	10000	/* max wait time for REQ/SACK assertion
-					   or negation, 10000us == 10ms */
-
-/*
- * structure for connected LUN dynamic data
- *
- * Note: Currently tagged queuing is disabled, each nsp32_lunt holds
- *       one SCSI command and one state.
- */
-#define DISCPRIV_OK		BIT(0)		/* DISCPRIV Enable mode */
-#define MSGIN03			BIT(1)		/* Auto Msg In 03 Flag */
-
-struct nsp32_lunt {
-	Scsi_Cmnd		*SCpnt;		/* Current Handling Scsi_Cmnd */
-	unsigned long		save_datp;	/* Save Data Pointer - saved position from initial address */
-	int			msgin03;	/* auto msg in 03 flag */
-	unsigned int		sg_num;		/* Total number of SG entries */
-	int			cur_entry;	/* Current SG entry number */
-	struct nsp32_sglun	*sglun;		/* sg table per lun */
-	long			sglun_paddr;	/* sglun physical address */
-};
-
-
-/*
  * Period/AckWidth speed conversion table
  *
  * Note: This period/ackwidth speed table must be in descending order.
  */
-static struct nsp32_sync_table nsp32_sync_table_40M[] = {
-     /* {PNo, AW,  SP,   EP}  Speed(MB/s) Period AckWidth */
-	{0x1, 0, 0x0c, 0x0c},	/*  20.0 :  50ns,  25ns */
-	{0x2, 0, 0x0d, 0x18},	/*  13.3 :  75ns,  25ns */
-	{0x3, 1, 0x19, 0x19},	/*  10.0 : 100ns,  50ns */
-	{0x4, 1, 0x1a, 0x1f},	/*   8.0 : 125ns,  50ns */
-	{0x5, 2, 0x20, 0x25},	/*   6.7 : 150ns,  75ns */
-	{0x6, 2, 0x26, 0x31},	/*   5.7 : 175ns,  75ns */
-	{0x7, 3, 0x32, 0x32},	/*   5.0 : 200ns, 100ns */
-	{0x8, 3, 0x33, 0x38},	/*   4.4 : 225ns, 100ns */
-	{0x9, 3, 0x39, 0x3e},	/*   4.0 : 250ns, 100ns */
+static nsp32_sync_table nsp32_sync_table_40M[] = {
+     /* {PNo, AW,   SP,   EP, SREQ smpl}  Speed(MB/s) Period AckWidth */
+	{0x1,  0, 0x0c, 0x0c, SMPL_40M},  /*  20.0 :  50ns,  25ns */
+	{0x2,  0, 0x0d, 0x18, SMPL_40M},  /*  13.3 :  75ns,  25ns */
+	{0x3,  1, 0x19, 0x19, SMPL_40M},  /*  10.0 : 100ns,  50ns */
+	{0x4,  1, 0x1a, 0x1f, SMPL_20M},  /*   8.0 : 125ns,  50ns */
+	{0x5,  2, 0x20, 0x25, SMPL_20M},  /*   6.7 : 150ns,  75ns */
+	{0x6,  2, 0x26, 0x31, SMPL_20M},  /*   5.7 : 175ns,  75ns */
+	{0x7,  3, 0x32, 0x32, SMPL_20M},  /*   5.0 : 200ns, 100ns */
+	{0x8,  3, 0x33, 0x38, SMPL_10M},  /*   4.4 : 225ns, 100ns */
+	{0x9,  3, 0x39, 0x3e, SMPL_10M},  /*   4.0 : 250ns, 100ns */
+	{0xa,  3, 0x3f, 0x44, SMPL_10M},  /*   3.64: 275ns, 100ns */
+	{0xb,  3, 0x45, 0x4b, SMPL_10M},  /*   3.33: 300ns, 100ns */
+	{0xc,  3, 0x4c, 0x53, SMPL_10M},  /*   3.01: 325ns, 100ns */
+	{0xd,  3, 0x54, 0x57, SMPL_10M},  /*   2.86: 350ns, 100ns */
+	{0xe,  3, 0x58, 0x5d, SMPL_10M},  /*   2.67: 375ns, 100ns */
+	{0xf,  3, 0x5e, 0x64, SMPL_10M},  /*   2.5 : 400ns, 100ns */
 };
-static const int nsp32_table_40M_num =
-		sizeof(nsp32_sync_table_40M)/sizeof(struct nsp32_sync_table);
 
-static struct nsp32_sync_table nsp32_sync_table_20M[] = {
-	{0x1, 0, 0x19, 0x19},	/* 10.0 : 100ns,  50ns */
-	{0x2, 0, 0x1a, 0x25},	/*  6.7 : 150ns,  50ns */
-	{0x3, 1, 0x26, 0x32},	/*  5.0 : 200ns, 100ns */
-	{0x4, 1, 0x33, 0x3e},	/*  4.0 : 250ns, 100ns */
-	{0x5, 2, 0x3f, 0x4b},	/*  3.3 : 300ns, 150ns */
-	{0x6, 2, 0x4c, 0x57},	/*  2.8 : 350ns, 150ns */
-	{0x7, 3, 0x58, 0x64},	/*  2.5 : 400ns, 200ns */
-	{0x8, 3, 0x65, 0x70},	/*  2.2 : 450ns, 200ns */
-	{0x9, 3, 0x71, 0x7d},	/*  2.0 : 500ns, 200ns */
+static nsp32_sync_table nsp32_sync_table_20M[] = {
+	{0x1,  0, 0x19, 0x19, SMPL_40M},  /* 10.0 : 100ns,  50ns */
+	{0x2,  0, 0x1a, 0x25, SMPL_20M},  /*  6.7 : 150ns,  50ns */
+	{0x3,  1, 0x26, 0x32, SMPL_20M},  /*  5.0 : 200ns, 100ns */
+	{0x4,  1, 0x33, 0x3e, SMPL_10M},  /*  4.0 : 250ns, 100ns */
+	{0x5,  2, 0x3f, 0x4b, SMPL_10M},  /*  3.3 : 300ns, 150ns */
+	{0x6,  2, 0x4c, 0x57, SMPL_10M},  /*  2.8 : 350ns, 150ns */
+	{0x7,  3, 0x58, 0x64, SMPL_10M},  /*  2.5 : 400ns, 200ns */
+	{0x8,  3, 0x65, 0x70, SMPL_10M},  /*  2.2 : 450ns, 200ns */
+	{0x9,  3, 0x71, 0x7d, SMPL_10M},  /*  2.0 : 500ns, 200ns */
+	{0xa,  3, 0x7e, 0x89, SMPL_10M},  /*  1.82: 550ns, 200ns */
+	{0xb,  3, 0x8a, 0x95, SMPL_10M},  /*  1.67: 550ns, 200ns */
+	{0xc,  3, 0x96, 0xa2, SMPL_10M},  /*  1.54: 550ns, 200ns */
+	{0xd,  3, 0xa3, 0xae, SMPL_10M},  /*  1.43: 550ns, 200ns */
+	{0xe,  3, 0xaf, 0xbb, SMPL_10M},  /*  1.33: 550ns, 200ns */
+	{0xf,  3, 0xbc, 0xc8, SMPL_10M},  /*  1.25: 550ns, 200ns */
 };
-static const int nsp32_table_20M_num =
-		sizeof(nsp32_sync_table_20M)/sizeof(struct nsp32_sync_table);
 
-static struct nsp32_sync_table nsp32_sync_table_pci[] = {
-	{0x1, 0, 0x0c, 0x0f},	/* 16.6 :  60ns,  30ns */
-	{0x2, 0, 0x10, 0x16},	/* 11.1 :  90ns,  30ns */
-	{0x3, 1, 0x17, 0x1e},	/*  8.3 : 120ns,  60ns */
-	{0x4, 1, 0x1f, 0x25},	/*  6.7 : 150ns,  60ns */
-	{0x5, 2, 0x26, 0x2d},	/*  5.6 : 180ns,  90ns */
-	{0x6, 2, 0x2e, 0x34},	/*  4.8 : 210ns,  90ns */
-	{0x7, 3, 0x35, 0x3c},	/*  4.2 : 240ns, 120ns */
-	{0x8, 3, 0x3d, 0x43},	/*  3.7 : 270ns, 120ns */
-	{0x9, 3, 0x44, 0x4b}, 	/*  3.3 : 300ns, 120ns */
+static nsp32_sync_table nsp32_sync_table_pci[] = {
+	{0x1,  0, 0x0c, 0x0f, SMPL_40M},  /* 16.6 :  60ns,  30ns */
+	{0x2,  0, 0x10, 0x16, SMPL_40M},  /* 11.1 :  90ns,  30ns */
+	{0x3,  1, 0x17, 0x1e, SMPL_20M},  /*  8.3 : 120ns,  60ns */
+	{0x4,  1, 0x1f, 0x25, SMPL_20M},  /*  6.7 : 150ns,  60ns */
+	{0x5,  2, 0x26, 0x2d, SMPL_20M},  /*  5.6 : 180ns,  90ns */
+	{0x6,  2, 0x2e, 0x34, SMPL_10M},  /*  4.8 : 210ns,  90ns */
+	{0x7,  3, 0x35, 0x3c, SMPL_10M},  /*  4.2 : 240ns, 120ns */
+	{0x8,  3, 0x3d, 0x43, SMPL_10M},  /*  3.7 : 270ns, 120ns */
+	{0x9,  3, 0x44, 0x4b, SMPL_10M},  /*  3.3 : 300ns, 120ns */
+	{0xa,  3, 0x4c, 0x53, SMPL_10M},  /*  3.0 : 330ns, 120ns */
+	{0xb,  3, 0x54, 0x59, SMPL_10M},  /*  2.8 : 360ns, 120ns */
+	{0xc,  3, 0x5a, 0x60, SMPL_10M},  /*  2.6 : 390ns, 120ns */
+	{0xd,  3, 0x61, 0x68, SMPL_10M},  /*  2.4 : 420ns, 120ns */
+	{0xe,  3, 0x69, 0x71, SMPL_10M},  /*  2.2 : 450ns, 120ns */
+	{0xf,  3, 0x72, 0x77, SMPL_10M},  /*  2.1 : 480ns, 120ns */
 };
-static const int nsp32_table_pci_num =
-		sizeof(nsp32_sync_table_pci)/sizeof(struct nsp32_sync_table);
 
 /*
  * function declaration
  */
-static int nsp32_detect(Scsi_Host_Template *);
-static int nsp32_queuecommand(Scsi_Cmnd *, void (*done)(Scsi_Cmnd *));
-static const char *nsp32_info(struct Scsi_Host *);
-static int nsp32_eh_abort(Scsi_Cmnd *);
-static int nsp32_eh_bus_reset(Scsi_Cmnd *);
-static int nsp32_eh_host_reset(Scsi_Cmnd *);
-static int nsp32_reset(Scsi_Cmnd *, unsigned int);
-static int nsp32_release(struct Scsi_Host *);
-static int nsp32_proc_info(char *, char **, off_t, int, int, int);
-static int __devinit nsp32_probe(struct pci_dev *, const struct pci_device_id *);
+/* module entry point */
+static int  __devinit nsp32_probe (struct pci_dev *, const struct pci_device_id *);
 static void __devexit nsp32_remove(struct pci_dev *);
-static int __init init_nsp32(void);
-static void __exit exit_nsp32(void);
+static int  __init    init_nsp32  (void);
+static void __exit    exit_nsp32  (void);
+
+/* struct Scsi_Host_Template */
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2,5,73))
+static int         nsp32_proc_info   (struct Scsi_Host *, char *, char **, off_t, int, int);
+#else
+static int         nsp32_proc_info   (char *, char **, off_t, int, int, int);
+#endif
 
-static void nsp32_message(char *, int, char *, char *, ...);
-static void nsp32_dmessage(char *, int, int, char *, ...);
-static void nsp32_build_identify(nsp32_hw_data *, Scsi_Cmnd *);
-static void nsp32_build_sdtr(nsp32_hw_data *, unsigned char, unsigned char);
-static void nsp32_build_nop(nsp32_hw_data *);
-static void nsp32_build_reject(nsp32_hw_data *);
-static int nsp32hw_start_selection(Scsi_Cmnd *, nsp32_hw_data *);
-static int nsp32_selection_autoscsi(Scsi_Cmnd *, nsp32_hw_data *);
-static int nsp32_reselection(nsp32_hw_data *, unsigned char);
-static int nsp32hw_setup_sg_table(Scsi_Cmnd *, nsp32_hw_data *);
-static int nsp32hw_init(struct Scsi_Host *);
-static void nsp32_scsi_done(nsp32_hw_data *, Scsi_Cmnd *);
-static int nsp32_busfree_occur(nsp32_hw_data *, unsigned short);
-static void nsp32_adjust_busfree(nsp32_hw_data *, unsigned int);
-static void nsp32_msgout_occur(nsp32_hw_data *);
-static void nsp32_restart_autoscsi(nsp32_hw_data *, unsigned short);
-static void nsp32_msgin_occur(nsp32_hw_data *, unsigned long, unsigned short);
-static void nsp32_analyze_sdtr(nsp32_hw_data *);
-static int nsp32_search_period_entry(nsp32_hw_data *,struct nsp32_target *, unsigned char);
-static void nsp32_set_async(nsp32_hw_data *, struct nsp32_target *);
-static void nsp32_set_max_sync(nsp32_hw_data *, struct nsp32_target *, unsigned char *, unsigned char *);
-static void nsp32_set_sync_entry(nsp32_hw_data *, struct nsp32_target *, int, unsigned char);
-static void nsp32_wait_req(nsp32_hw_data *, int);
-static void nsp32_wait_sack(nsp32_hw_data *, int);
-static void nsp32_sack_assert(nsp32_hw_data *);
-static void nsp32_sack_negate(nsp32_hw_data *);
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2,5,73))
+static int         nsp32_detect      (struct pci_dev *pdev);
+#else
+static int         nsp32_detect      (Scsi_Host_Template *);
+#endif
+static int         nsp32_queuecommand(Scsi_Cmnd *, void (*done)(Scsi_Cmnd *));
+static const char *nsp32_info        (struct Scsi_Host *);
+static int         nsp32_release     (struct Scsi_Host *);
+
+/* SCSI error handler */
+static int         nsp32_eh_abort     (Scsi_Cmnd *);
+static int         nsp32_eh_bus_reset (Scsi_Cmnd *);
+static int         nsp32_eh_host_reset(Scsi_Cmnd *);
+
+/* generate SCSI message */
+static void nsp32_build_identify(Scsi_Cmnd *);
+static void nsp32_build_nop     (Scsi_Cmnd *);
+static void nsp32_build_reject  (Scsi_Cmnd *);
+static void nsp32_build_sdtr    (Scsi_Cmnd *, unsigned char, unsigned char);
+
+/* SCSI message handler */
+static int  nsp32_busfree_occur(Scsi_Cmnd *, unsigned short);
+static void nsp32_msgout_occur (Scsi_Cmnd *);
+static void nsp32_msgin_occur  (Scsi_Cmnd *, unsigned long, unsigned short);
+
+static int           nsp32_setup_sg_table    (Scsi_Cmnd *);
+static unsigned long nsp32_msgout_register   (Scsi_Cmnd *);
+static int           nsp32_selection_autopara(Scsi_Cmnd *);
+static int           nsp32_selection_autoscsi(Scsi_Cmnd *);
+static void          nsp32_scsi_done         (Scsi_Cmnd *);
+static int           nsp32_arbitration       (Scsi_Cmnd *, unsigned int);
+static int           nsp32_reselection       (Scsi_Cmnd *, unsigned char);
+static void          nsp32_adjust_busfree    (Scsi_Cmnd *, unsigned int);
+static void          nsp32_restart_autoscsi  (Scsi_Cmnd *, unsigned short);
+
+/* SCSI SDTR */
+static void nsp32_analyze_sdtr       (Scsi_Cmnd *);
+static int  nsp32_search_period_entry(nsp32_hw_data *, nsp32_target *, unsigned char);
+static void nsp32_set_async          (nsp32_hw_data *, nsp32_target *);
+static void nsp32_set_max_sync       (nsp32_hw_data *, nsp32_target *, unsigned char *, unsigned char *);
+static void nsp32_set_sync_entry     (nsp32_hw_data *, nsp32_target *, int, unsigned char);
+
+/* SCSI bus status handler */
+static void nsp32_wait_req    (nsp32_hw_data *, int);
+static void nsp32_wait_sack   (nsp32_hw_data *, int);
+static void nsp32_sack_assert (nsp32_hw_data *);
+static void nsp32_sack_negate (nsp32_hw_data *);
 static void nsp32_do_bus_reset(nsp32_hw_data *);
-static void do_nsp32_isr(int, void *, struct pt_regs *);
 
-static int nsp32_getprom_param(nsp32_hw_data *);
-static int nsp32_getprom_new(nsp32_hw_data *);
-static int nsp32_getprom_standard(nsp32_hw_data *);
-static int nsp32_prom_read(nsp32_hw_data *, int);
-static void nsp32_prom_start(nsp32_hw_data *);
-static void nsp32_prom_stop(nsp32_hw_data *);
-static void nsp32_prom_write(nsp32_hw_data *, int);
-static int nsp32_prom_fetch(nsp32_hw_data *);
-static inline void nsp32_prom_set(nsp32_hw_data *, int, int);
-static inline int nsp32_prom_get(nsp32_hw_data *, int);
+/* hardware interrupt handler */
+static irqreturn_t do_nsp32_isr(int, void *, struct pt_regs *);
+
+/* initialize hardware */
+static int  nsp32hw_init(nsp32_hw_data *);
+
+/* EEPROM handler */
+static        int  nsp32_getprom_param (nsp32_hw_data *);
+static        int  nsp32_getprom_at24  (nsp32_hw_data *);
+static        int  nsp32_getprom_c16   (nsp32_hw_data *);
+static        void nsp32_prom_start    (nsp32_hw_data *);
+static        void nsp32_prom_stop     (nsp32_hw_data *);
+static        int  nsp32_prom_read     (nsp32_hw_data *, int);
+static        int  nsp32_prom_read_bit (nsp32_hw_data *);
+static        void nsp32_prom_write_bit(nsp32_hw_data *, int);
+static inline void nsp32_prom_set      (nsp32_hw_data *, int, int);
+static inline int  nsp32_prom_get      (nsp32_hw_data *, int);
 
+/* debug/warning/info message */
+static void nsp32_message (const char *, int, char *, char *, ...);
+#ifdef NSP32_DEBUG
+static void nsp32_dmessage(const char *, int, int,    char *, ...);
+#endif
 
 /*
  * max_sectors is currently limited up to 128.
  */
-static Scsi_Host_Template driver_template = {
-	.proc_name =			"nsp32",
-	.name =				"Workbit NinjaSCSI-32Bi/UDE",
-	.proc_info =			nsp32_proc_info,
-	.detect =			nsp32_detect,
-	.info =				nsp32_info,
-	.queuecommand =			nsp32_queuecommand,
-	.can_queue =			1,
-	.sg_tablesize =			NSP_SG_SIZE,
-	.max_sectors =			128,
-	.cmd_per_lun =			1,
-	.this_id =			7,
-	.use_clustering =		DISABLE_CLUSTERING,
-	.eh_abort_handler =       	nsp32_eh_abort,
-	.eh_device_reset_handler =	NULL,
-	.eh_bus_reset_handler =		nsp32_eh_bus_reset,
-	.eh_host_reset_handler =	nsp32_eh_host_reset,
-	.reset =			nsp32_reset,
-	.release =			nsp32_release,
-#if (LINUX_VERSION_CODE < KERNEL_VERSION(2,5,2))
-	.use_new_eh_code =        	1,
+static Scsi_Host_Template nsp32_template = {
+	.proc_name			= "nsp32",
+	.name				= "Workbit NinjaSCSI-32Bi/UDE",
+	.proc_info			= nsp32_proc_info,
+	.info				= nsp32_info,
+	.queuecommand			= nsp32_queuecommand,
+	.can_queue			= 1,
+	.sg_tablesize			= NSP32_SG_SIZE,
+	.max_sectors			= 128,
+	.cmd_per_lun			= 1,
+	.this_id			= NSP32_HOST_SCSIID,
+	.use_clustering			= DISABLE_CLUSTERING,
+	.eh_abort_handler       	= nsp32_eh_abort,
+/*	.eh_device_reset_handler	= NULL, */
+	.eh_bus_reset_handler		= nsp32_eh_bus_reset,
+	.eh_host_reset_handler		= nsp32_eh_host_reset,
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(2,5,74))
+	.detect				= nsp32_detect,
+	.release			= nsp32_release,
+	.use_new_eh_code        	= 1,
 #else
-	/* .highmem_io =		1,	*/
+/*	.highmem_io			= 1, */
 #endif
 };
 
 #include "nsp32_io.h"
 
-/*
+/***********************************************************************
  * debug, error print
  */
-#define nsp32_msg(type, args...) \
-	nsp32_message(__FUNCTION__, __LINE__, (type), ## args)
-#define nsp32_dbg(mask, args...) \
-	nsp32_dmessage(__FUNCTION__, __LINE__, (mask), ## args)
-
 #ifndef NSP32_DEBUG
-# define NSP32_DEBUG_MASK		0x000000
+# define NSP32_DEBUG_MASK	      0x000000
+# define nsp32_msg(type, args...)     nsp32_message ("", 0, (type), args)
+# define nsp32_dbg(mask, args...)     /* */
 #else
-# define NSP32_DEBUG_MASK		0xffffff
+# define NSP32_DEBUG_MASK	      0xffffff
+# define nsp32_msg(type, args...) \
+	nsp32_message (__FUNCTION__, __LINE__, (type), args)
+# define nsp32_dbg(mask, args...) \
+	nsp32_dmessage(__FUNCTION__, __LINE__, (mask), args)
 #endif
 
-#define NSP32_DEBUG_QUEUECOMMAND	0x000001
-#define NSP32_DEBUG_REGISTER		0x000002
-#define NSP32_DEBUG_AUTOSCSI		0x000004
-#define NSP32_DEBUG_INTR		0x000008
-#define NSP32_DEBUG_SGLIST		0x000010
-#define NSP32_DEBUG_BUSFREE		0x000020
-#define NSP32_DEBUG_CDB_CONTENTS	0x000040
-#define NSP32_DEBUG_RESELECTION		0x000080
-#define NSP32_DEBUG_MSGINOCCUR		0x000100
-#define NSP32_DEBUG_EEPROM		0x000200
-#define NSP32_DEBUG_MSGOUTOCCUR		0x000400
-#define NSP32_DEBUG_BUSRESET		0x000800
-#define NSP32_DEBUG_RESTART		0x001000
-#define NSP32_DEBUG_SYNC		0x002000
-#define NSP32_DEBUG_WAIT		0x004000
-#define NSP32_DEBUG_TARGETFLAG		0x008000
-#define NSP32_DEBUG_PROC		0x010000
-#define NSP32_DEBUG_INIT		0x020000
-#define NSP32_SPECIAL_PRINT_REGISTER	0x100000
+#define NSP32_DEBUG_QUEUECOMMAND	BIT(0)
+#define NSP32_DEBUG_REGISTER		BIT(1)
+#define NSP32_DEBUG_AUTOSCSI		BIT(2)
+#define NSP32_DEBUG_INTR		BIT(3)
+#define NSP32_DEBUG_SGLIST		BIT(4)
+#define NSP32_DEBUG_BUSFREE		BIT(5)
+#define NSP32_DEBUG_CDB_CONTENTS	BIT(6)
+#define NSP32_DEBUG_RESELECTION		BIT(7)
+#define NSP32_DEBUG_MSGINOCCUR		BIT(8)
+#define NSP32_DEBUG_EEPROM		BIT(9)
+#define NSP32_DEBUG_MSGOUTOCCUR		BIT(10)
+#define NSP32_DEBUG_BUSRESET		BIT(11)
+#define NSP32_DEBUG_RESTART		BIT(12)
+#define NSP32_DEBUG_SYNC		BIT(13)
+#define NSP32_DEBUG_WAIT		BIT(14)
+#define NSP32_DEBUG_TARGETFLAG		BIT(15)
+#define NSP32_DEBUG_PROC		BIT(16)
+#define NSP32_DEBUG_INIT		BIT(17)
+#define NSP32_SPECIAL_PRINT_REGISTER	BIT(20)
 
 #define NSP32_DEBUG_BUF_LEN		100
 
-static void nsp32_message(char *func, int line, char *type, char *fmt, ...)
+static void nsp32_message(const char *func, int line, char *type, char *fmt, ...)
 {
 	va_list args;
 	char buf[NSP32_DEBUG_BUF_LEN];
 
 	va_start(args, fmt);
-	vsprintf(buf, fmt, args);
+	vsnprintf(buf, sizeof(buf), fmt, args);
 	va_end(args);
 
 #ifndef NSP32_DEBUG
@@ -415,19 +379,21 @@
 #endif
 }
 
-static void nsp32_dmessage(char *func, int line, int mask, char *fmt, ...)
+#ifdef NSP32_DEBUG
+static void nsp32_dmessage(const char *func, int line, int mask, char *fmt, ...)
 {
 	va_list args;
 	char buf[NSP32_DEBUG_BUF_LEN];
 
 	va_start(args, fmt);
-	vsprintf(buf, fmt, args);
+	vsnprintf(buf, sizeof(buf), fmt, args);
 	va_end(args);
 
 	if (mask & NSP32_DEBUG_MASK) {
-		printk("Ninja: %d %s (%d): %s\n", mask, func, line, buf);
+		printk("nsp32-debug: 0x%x %s (%d): %s\n", mask, func, line, buf);
 	}
 }
+#endif
 
 #ifdef NSP32_DEBUG
 # include "nsp32_debug.c"
@@ -437,56 +403,51 @@
 # define show_autophase(arg) /* */
 #endif
 
-#ifdef NSP32_DEBUG
-static int pc_debug = NSP32_DEBUG;
-MODULE_PARM(pc_debug, "i");
-#define DEBUG(n, args...) if (pc_debug>(n)) printk(/*KERN_DEBUG*/ args)
-#else
-#define DEBUG(n, args...)
-#endif
-
-
 /*
  * IDENTIFY Message
  */
-static void nsp32_build_identify(nsp32_hw_data *data, Scsi_Cmnd *SCpnt)
+static void nsp32_build_identify(Scsi_Cmnd *SCpnt)
 {
-	int pos = data->msgoutlen;
+	nsp32_hw_data *data = (nsp32_hw_data *)SCpnt->device->host->hostdata;
+	int pos             = data->msgout_len;
+	int mode            = FALSE;
 
-	data->msgoutbuf[pos++] =
-		0x80 |		/* Identify */
-#if 0
-		/* XXX: Auto DiscPriv detection is progressing... */
-		0x40 |		/* DiscPriv */
-#endif
-		SCpnt->lun;	/* LUNTRN */
+	/* XXX: Auto DiscPriv detection is progressing... */
+	if (disc_priv == 0) {
+		/* mode = TRUE; */
+	}
 
-	data->msgoutlen = pos;
+	data->msgoutbuf[pos] = IDENTIFY(mode, SCpnt->device->lun); pos++;
+
+	data->msgout_len = pos;
 }
 
 /*
  * SDTR Message Routine
  */
-static void nsp32_build_sdtr(nsp32_hw_data *data,
-			     unsigned char period, unsigned char offset)
-{
-	int pos = data->msgoutlen;
+static void nsp32_build_sdtr(Scsi_Cmnd    *SCpnt,
+			     unsigned char period,
+			     unsigned char offset)
+{
+	nsp32_hw_data *data = (nsp32_hw_data *)SCpnt->device->host->hostdata;
+	int pos             = data->msgout_len;
+
+	data->msgoutbuf[pos] = EXTENDED_MESSAGE;  pos++;
+	data->msgoutbuf[pos] = EXTENDED_SDTR_LEN; pos++;
+	data->msgoutbuf[pos] = EXTENDED_SDTR;     pos++;
+	data->msgoutbuf[pos] = period;            pos++;
+	data->msgoutbuf[pos] = offset;            pos++;
 
-	data->msgoutbuf[pos++] = EXTENDED_MESSAGE;
-	data->msgoutbuf[pos++] = EXTENDED_SDTR_LEN;
-	data->msgoutbuf[pos++] = EXTENDED_SDTR;
-	data->msgoutbuf[pos++] = period;
-	data->msgoutbuf[pos++] = offset;
-
-	data->msgoutlen = pos;
+	data->msgout_len = pos;
 }
 
 /*
  * No Operation Message
  */
-static void nsp32_build_nop(nsp32_hw_data *data)
+static void nsp32_build_nop(Scsi_Cmnd *SCpnt)
 {
-	int pos = data->msgoutlen;
+	nsp32_hw_data *data = (nsp32_hw_data *)SCpnt->device->host->hostdata;
+	int            pos  = data->msgout_len;
 
 	if (pos != 0) {
 		nsp32_msg(KERN_WARNING,
